

static Widget interface_title_widget,  ms_label_widget,  account_label_widget,  
  change_label_widget,  repay_button_widget, drinks_button_widget[DRINKS_DIFF], coins_button_widget[COINS_DIFF];

#define DRINKS_STRINGS_LENGTH 28

void interface_InitStrings()
{
  int i,l;
  char * s;

  l=0;
  for (i=0;i<DRINKS_DIFF;i++)
    {
      if (strlen(DRINKS_STRINGS[i])>l)
	l = strlen(DRINKS_STRINGS[i]);
    };
  for (i=0;i<DRINKS_DIFF;i++)
    {
      s = DRINKS_STRINGS[i];
      DRINKS_STRINGS[i] = (char *) malloc (DRINKS_STRINGS_LENGTH+1);
      strcpy(DRINKS_STRINGS[i]," ");
      strncat(DRINKS_STRINGS[i],s,DRINKS_STRINGS_LENGTH-1);
      while (strlen(DRINKS_STRINGS[i])!=DRINKS_STRINGS_LENGTH)
	strcat(DRINKS_STRINGS[i]," ");
    }
}

void create_interface_title(Widget widget)
{ interface_title_widget = widget; }

void create_account_label(Widget widget)
{ account_label_widget = widget; }

void create_ms_label(Widget widget)
{ ms_label_widget = widget; }

void create_change_label( Widget widget)
{ change_label_widget = widget; }

void create_repay( Widget widget)
{ repay_button_widget = widget; }

/* READING INPUTS                                          */
/*=========================================================*/

static int vdrinkno;
static logical vcoin[COINS_DIFF];
static logical vrepay;

void init_coin()
{ 
  int i;
  for (i=0;i<COINS_DIFF;i++)
    vcoin[i] = FALSE; 
}

void init_drinkno()
{ vdrinkno = 0; }

void init_repay()
{ vrepay = FALSE; }

void INIT_USER_INPUTS()
{ 
  init_coin();
  init_drinkno();
  init_repay(); 
}

void push_repay()
{ vrepay = TRUE; }

void SCAN_USER_INPUTS( logical * coin, int * drinkno, logical * repay)
{ 
  int i;
  for (i=0; i<COINS_DIFF; i++) coin[i] = vcoin[i];

  *repay = vrepay;
  *drinkno = vdrinkno;
  INIT_USER_INPUTS();
}


/*        PRINTING OUTPUTS                            */
/*====================================================*/

void PRINT_ACCOUNT(float account)
{ 
  char s[128];
  if (MONEY_SYMBOL_BEFORE)
    sprintf(s,"%s%s %s%.2f",ACCOUNT_STRING,TWO_POINTS_STRING,MONEY_SYMBOL,account);
  else
    sprintf(s,"%s%s %.2f%s",ACCOUNT_STRING,TWO_POINTS_STRING,account,MONEY_SYMBOL);
  putlabel(account_label_widget,s);
}

void PRINT_MACHINE_STATE(logical ms)
{ 
  putlabel(ms_label_widget,ms? INSERT_COINS_STRING:PLEASE_WAIT_STRING);
}

void PRINT_CHANGE(logical c)
{ 
  putlabel(change_label_widget,c ? PAYS_BACK_STRING:NO_CHANGE_STRING);
}


/*        TEXT INITIALISATION                              */
/*=========================================================*/

void INTERFACE_INIT_LABELS(float * prices)
{
  int i;
  char s[128];

  putlabel(interface_title_widget,INTERFACE_TITLE);
  for (i=0;i<COINS_DIFF;i++)
    {
      sprintf(s,"%s",COINS_STRINGS[i]);
      putlabel(coins_button_widget[i],s);
    }
  putlabel(repay_button_widget,REPAY_STRING);
  for (i=0;i<DRINKS_DIFF;i++)
    {
      sprintf(s,"%s%-5.2f%s",DRINKS_STRINGS[i],prices[i],MONEY_SYMBOL);
      putlabel(drinks_button_widget[i],s);
    }
}

/*        CALLBACKS FOR BANK            */
/*======================================*/

CallBackName coins_button_create_str[COINS_DIFF];

#define DEFINE_COIN(i)   \
void push_coin_##i()     \
{                        \
  init_coin();           \
  vcoin[ i -1] = TRUE; \
}                        \
void create_coin_##i##_button(Widget widget)    \
{                                               \
  coins_button_widget[ i-1] = widget;         \
  XtVaSetValues(widget, XmNbackground, whiteColor, NULL); \
}                                                                       

#include "coins_def.h"

/*        CALLBACKS FOR DRINK          */
/*=====================================*/

CallBackName drinks_button_create_str[DRINKS_DIFF];

#define DEFINE_DRINK(i) \
void push_drink_##i()   \
{                       \
  vdrinkno = i ;      \
}                       \
void create_drink_##i##_button( Widget widget) \
{                                              \
  drinks_button_widget[ i -1] = widget;      \
  XtVaSetValues(widget, XmNbackground, whiteColor, NULL);\
}                                                                       

