
#include "bank.c"
#include "interface.c"

#include "drinks_nb.h"
#include "drinks_def.h"


static void  mk_ORDER_BOX(Widget ORDER_BOX)
{
  Widget COINS_BOX, REPAY_BUT, ACCOUNT_BOX;
  Widget b1, b2, b3, b4, b5;
  Widget ACCOUNT_BOX1, ACCOUNT_BOX2;

  COINS_BOX = XtVaCreateManagedWidget("coins", xmFormWidgetClass,ORDER_BOX, NULL);

  b1 = make_button(COINS_STRINGS[0],COINS_BOX , 2);
  create_coin_1_button(b1);
  XtAddCallback(b1, XmNactivateCallback, (XtCallbackProc)push_coin_1, NULL);
  
  b2 = make_button(COINS_STRINGS[1],COINS_BOX , 2);
  create_coin_2_button(b2);
  XtVaSetValues(b2, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, b1, NULL);
  XtAddCallback(b2, XmNactivateCallback, (XtCallbackProc)push_coin_2, NULL);

  b3 = make_button(COINS_STRINGS[2],COINS_BOX , 2);
  create_coin_3_button(b3);
  XtVaSetValues(b3, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, b2, NULL);  
  XtAddCallback(b3, XmNactivateCallback, (XtCallbackProc)push_coin_3, NULL);

  b4 = make_button(COINS_STRINGS[3],COINS_BOX , 2);
  create_coin_4_button(b4);
  XtVaSetValues(b4, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, b3, NULL);  
  XtAddCallback(b4, XmNactivateCallback, (XtCallbackProc)push_coin_4, NULL);

  b5 = make_button(COINS_STRINGS[4],COINS_BOX , 2);
  create_coin_5_button(b5);
  XtVaSetValues(b5, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, b4, NULL);  
  XtAddCallback(b5, XmNactivateCallback, (XtCallbackProc)push_coin_5, NULL);

  REPAY_BUT= make_button(REPAY_STRING,ORDER_BOX , 2);
  XtVaSetValues(REPAY_BUT, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, COINS_BOX, NULL);
  XtAddCallback(REPAY_BUT, XmNactivateCallback, (XtCallbackProc) push_repay, NULL);
  create_repay(REPAY_BUT);

  ACCOUNT_BOX = XtVaCreateManagedWidget("Account", xmFormWidgetClass, ORDER_BOX, 
					XmNleftAttachment, XmATTACH_FORM, 
					XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, COINS_BOX,
					NULL);
  ACCOUNT_BOX1= make_label(ACCOUNT_STRING,ACCOUNT_BOX, BUTTON_HEIGHT);
  XtVaSetValues(ACCOUNT_BOX1, XmNbackground, redColor, NULL);
  create_account_label(ACCOUNT_BOX1);
}


static Widget make_buttonDRINKS(char *name, Widget father)
{
  return make_button1( name, father, 2, 200);
}

static void mk_DRINKS_BOX(Widget DRINKS_BOX)
{ 
  Widget b1, b2, b3, b4, b5, b6;

  b1 = make_buttonDRINKS("drink_1", DRINKS_BOX);
  XtAddCallback(b1, XmNactivateCallback, (XtCallbackProc)push_drink_1 , NULL);
  create_drink_1_button(b1);

  b2 = make_buttonDRINKS("drink_2", DRINKS_BOX);
  XtVaSetValues(b2, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, b1, NULL);
  XtAddCallback(b2, XmNactivateCallback, (XtCallbackProc)push_drink_2 , NULL);
  create_drink_2_button(b2);

  b3 = make_buttonDRINKS("drink_3", DRINKS_BOX);
  XtVaSetValues(b3, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, b2, NULL);
  XtAddCallback(b3, XmNactivateCallback, (XtCallbackProc)push_drink_3, NULL);
  create_drink_3_button(b3);

  b4 = make_buttonDRINKS("drink_4", DRINKS_BOX);
  XtVaSetValues(b4, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, b3, NULL);
  XtAddCallback(b4, XmNactivateCallback, (XtCallbackProc)push_drink_4, NULL);
  create_drink_4_button(b4);

  b5 = make_buttonDRINKS("drink_5", DRINKS_BOX);
  XtVaSetValues(b5, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, b4, NULL);
  XtAddCallback(b5, XmNactivateCallback, (XtCallbackProc)push_drink_5, NULL);
  create_drink_5_button(b5);

  b6 = make_buttonDRINKS("drink_6", DRINKS_BOX);
  XtVaSetValues(b6, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, b5, NULL);
  XtAddCallback(b6, XmNactivateCallback, (XtCallbackProc)push_drink_6, NULL);
  create_drink_6_button(b6);

}

void mk_INTERFACE_BOX(Widget wup)
{ 
  Widget INTERFACE_TITLE_BOX, INTERFACE_MAIN_BOX, MS_BOX, ORDER_BOX, DRINKS_BOX, CHANGE_BOX, w;
 
  w = XtVaCreateManagedWidget("interface", xmFormWidgetClass, wup, XmNwidth, DRAWING_AREA_WIDTH, NULL);
							
  INTERFACE_TITLE_BOX= make_label(INTERFACE_TITLE, w, BUTTON_HEIGHT);
  XtVaSetValues(INTERFACE_TITLE_BOX, XmNborderWidth, 1, NULL);
  create_interface_title(INTERFACE_TITLE_BOX);
  
  MS_BOX  = make_label(INSERT_COINS_STRING, w, BUTTON_HEIGHT);
  XtVaSetValues(MS_BOX, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, INTERFACE_TITLE_BOX, NULL);
  create_ms_label(MS_BOX);
  

  ORDER_BOX = XtVaCreateManagedWidget("orders", xmFormWidgetClass, w, 
				      XmNverticalSpacing, ESP_HEIGHT,
				      XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, MS_BOX,
				      NULL);

  mk_ORDER_BOX(ORDER_BOX);

  DRINKS_BOX = XtVaCreateManagedWidget("drinks", xmFormWidgetClass, w, 
				       XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, ORDER_BOX,
				       NULL);
  mk_DRINKS_BOX(DRINKS_BOX);

  MS_BOX  = make_label(PAYS_BACK_STRING, w, BUTTON_HEIGHT);
  XtVaSetValues(MS_BOX, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, DRINKS_BOX, NULL);
  create_change_label(MS_BOX);
}

void mk_BANK_BOX(Widget wup)
{
  Widget  w0,w1, w2, w3, w4, w5, w;

  XtVaSetValues(wup, XmNbackground, blueColor, NULL);
  w = XtVaCreateManagedWidget("mk_BANK_BOX", xmFormWidgetClass, wup,
			      XmNwidth, DRAWING_AREA_WIDTH,
			      XmNheight, DRAWING_AREA_HEIGHT,
			      NULL);
  XtVaSetValues(w, XmNbackground, blueColor, NULL);
  w0 = make_label(BANK_TITLE, w, BUTTON_HEIGHT);
  XtVaSetValues(w0, XmNleftAttachment, XmATTACH_FORM, NULL);
  create_bank_title(w0);
  XtVaSetValues(w0, XmNbackground, blueColor, NULL);

  w1 = make_label(COINS_STRINGS[0], w, BUTTON_HEIGHT);
  XtVaSetValues(w1, XmNverticalSpacing, ESP_HEIGHT, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w0, NULL);
  create_coin_1_label(w1);

  w2 = make_label(COINS_STRINGS[1], w, BUTTON_HEIGHT);
  XtVaSetValues(w2, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w1, NULL);
  create_coin_2_label(w2);

  w3 = make_label(COINS_STRINGS[2], w, BUTTON_HEIGHT);
  XtVaSetValues(w3, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w2, NULL);
  create_coin_3_label(w3);

  w4 = make_label(COINS_STRINGS[3], w, BUTTON_HEIGHT);
  XtVaSetValues(w4, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w3, NULL);
  create_coin_4_label(w4);

  w5 = make_label(COINS_STRINGS[4], w, BUTTON_HEIGHT);
  XtVaSetValues(w5, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w4, NULL);
  create_coin_5_label(w5);
  
}

void  LEFT_BOX(Widget left)
{
  Widget p, INTERFACE_BOX, BANK_BOX;
  
  p = XtVaCreateManagedWidget("left1", xmFormWidgetClass, left, XmNtopAttachment, XmATTACH_FORM, NULL);

  INTERFACE_BOX = XtVaCreateManagedWidget("left2", xmDrawingAreaWidgetClass, p, XmNborderWidth, 2, NULL);
  mk_INTERFACE_BOX (INTERFACE_BOX);
  
  BANK_BOX = XtVaCreateManagedWidget("left3", xmDrawingAreaWidgetClass, p, 
				     XmNborderWidth, 2,
				     XmNwidth, DRAWING_AREA_WIDTH, 
				     XmNheight, DRAWING_AREA_HEIGHT,
				     XmNleftAttachment, XmATTACH_FORM,
				     XmNrightAttachment, XmATTACH_FORM,
				     XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, INTERFACE_BOX,
				     NULL);
  mk_BANK_BOX(BANK_BOX);
}

