
#define PACE_PI_0 4      /* Initial period */
#define NUL_CODE 0
#define EXP_CODE 1
#define LIN_CODE 2

static Widget pace_title_widget, auto_button_widget, stop_button_widget, tick_button_widget, meter_label_widget;
static logical vstop,vauto,vtick,vupdown, vcode;

/*=========================================================*/
/*        Saving WIDGET                                    */
/*=========================================================*/

void create_pace_title(Widget widget)
{ pace_title_widget = widget; }

void create_auto(Widget widget)
{
  auto_button_widget = widget;
  vauto = FALSE;
  vtick = FALSE;
}

void create_stop(Widget widget)
{
  stop_button_widget = widget;
  vstop = FALSE;
}

void create_tick(Widget widget)
{ tick_button_widget = widget; }

void create_meter_pace(Widget widget)
{ 
  meter_label_widget = widget; 
  vcode = NUL_CODE;
}

/*=========================================================*/
/*        READING INPUTS                                   */
/*=========================================================*/

void push_auto()
{
  vauto = TRUE;
  vstop = FALSE;
  vtick = FALSE;
}

void push_stop()
{ vstop = TRUE; }

void push_tick()
{ vtick = TRUE; }

logical RAUTO()
{
  logical _auto;
  _auto = vauto;
  vauto = FALSE;
  return(_auto);
}

logical RSTOP()
{
  logical stop;
  stop = vstop;
  vstop = FALSE;
  return(stop);
}

logical RTICK()
{
  logical tick;
  tick = vtick;
  vtick = FALSE;
  return(tick);
}
void push_pace_up_p()
{
  vupdown = TRUE;
  vcode = LIN_CODE;
}

void push_pace_down_p()
{
  vupdown = FALSE;
  vcode = LIN_CODE;
}

void push_pace_down_m()
{
  vupdown = FALSE;
  vcode = EXP_CODE;
}

void push_pace_up_m()
{
  vupdown = TRUE;
  vcode = EXP_CODE;
}

int GET_PACE_RHYTHM()
{  return PACE_PI_0; }

logical RUPDOWN(logical h)
{
  logical updown;
  
  updown = vupdown;
  return(updown);
}

int RCHANGE(logical h)
{
  int code;
  
  code =vcode;
  vcode = NUL_CODE;
  return(code);
}

/*=========================================================*/
/*        WRITINGS                                         */
/*=========================================================*/

void RESET_PANEL(logical cauto)
{
  putlabel(auto_button_widget,cauto?MANU_STRING:AUTO_STRING);
}

void PRINT_RHYTHM(int v)
{
  /*
    char str_v[128];
    sprintf(str_v,"%10d",v);
    putlabel(meter_label_widget,str_v);
  */
}

void PACE_INIT_LABELS()
{
  /* -- DONE during PACE_BOX call --
    putlabel(pace_title_widget,PACE_TITLE);
    putlabel(stop_button_widget,QUIT_STRING);
    putlabel(auto_button_widget,AUTO_STRING);
    putlabel(tick_button_widget,TICK_STRING);
  */
}

static void PACE_BOX(Widget wup)
{
  Widget  w, w1, w2, widg1, widg2, widg3, widg4;

  w = wup;
  create_meter_pace(w);
  
  w2 = make_button(QUIT_STRING, w, 2);
  XtVaSetValues(w2, XmNbackground, redColor, NULL);
  XtAddCallback(w2, XmNactivateCallback, (XtCallbackProc)push_stop, NULL);
  create_stop(w2);

  w1 = make_button(AUTO_STRING, w, 2);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w2, NULL);
  XtAddCallback(w1, XmNactivateCallback, (XtCallbackProc)push_auto, NULL);
  create_auto(w1);

  w2 = make_button(TICK_STRING, w, 2);
  XtVaSetValues(w2, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);
  XtAddCallback(w2, XmNactivateCallback, (XtCallbackProc)push_tick, NULL);
  create_tick(w2);

  widg1 = make_button("+", w, 2);
  XtVaSetValues(widg1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w2, NULL);
  XtAddCallback(widg1, XmNactivateCallback, (XtCallbackProc)push_pace_up_p, NULL);

  widg2 = make_button("-", w, 2);
  XtVaSetValues(widg2, XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg1, NULL);
  XtAddCallback(widg2, XmNactivateCallback, (XtCallbackProc)push_pace_down_p, NULL);

  widg3 = make_button("/", w, 2);
  XtVaSetValues(widg3, XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg2, NULL);
  XtAddCallback(widg3, XmNactivateCallback, (XtCallbackProc)push_pace_down_m, NULL);

  widg4 = make_button("*", w, 2);
  XtVaSetValues(widg4, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg3, NULL);
  XtAddCallback(widg4, XmNactivateCallback, (XtCallbackProc) push_pace_up_m, NULL);
}
